#include<cstdlib>
#include<cmath>
#include<iostream>
#include<map>
#include<string>

struct A {
  static float getOneOverThirty ( );
};

float A::getOneOverThirty ( ) {
  return ( sqrt(1.f/900.f) );
}

void printAsHex ( const double Arg ) {
  std::cout << std::hex << * ( reinterpret_cast<const long long int*> ( &(Arg) ) );
}

int main ( const int, const char** const ) {
  // don't use set<floating point type> or map<floating point type, other type> unless you know what you are doing

  // some way of obtaining similar, but not equal values
  const double
    oneThirdA = 1.0/3.0f,
    oneThirdB = A::getOneOverThirty() / 2 + 9.5f * A::getOneOverThirty(),
    oneThirdC = 10.0f * A::getOneOverThirty();

  std::map<double, std::string> myMap;
  myMap [ oneThirdA ] = "one third A";
  myMap [ oneThirdB ] = "one third B";

  std::cout << "should be oneThird A or B: " << myMap [ 10.0f * A::getOneOverThirty() ] << std::endl;

  myMap [ oneThirdC ] = "one third C";

  for ( auto it = myMap.begin(); it != myMap.end(); ++it ) {
    std::cout << it->first << " " << it->second << " ";
    printAsHex ( it->first );
    std::cout << std::endl;
  }

  return ( EXIT_SUCCESS );
}
