#include<cstdlib>
#include<iostream>
#include<algorithm>

// example for own comparison used as maximum value

int weightedTimeSinceMeal ( const int Hour ) {
  static const int hPD = 24; // hours per day

  const int hour = Hour % hPD;
  if ( hour < 8 ) {
    return ( ( ( hPD + hour - 20 ) % hPD ) / 2 );
  } else if ( hour < 12 ) {
    return ( 2 * ( hour - 8 ) );
  } else if ( hour < 20 ) {
    return ( ( hour - 12 ) );
  } else {
    return ( ( ( hour - 20 ) % hPD ) / 2 );
  }
}

bool hungerCompare ( const int HourA, const int HourB ) {
  return ( weightedTimeSinceMeal ( HourA ) < weightedTimeSinceMeal ( HourB ) );
}

int main ( const int, const char** const ) {
  const int timeA = 11, timeB = 14;

  std::cout << "Comparing " << timeA << " and " << timeB << ", more hungry at " << std::max ( 11, 14, hungerCompare ) << std::endl;

  return ( EXIT_SUCCESS );
}
