#include<cstdlib>
#include<iostream>
#include<vector>


int main ( const int, const char** const ) {
  const unsigned int size = 10;

  std::vector<unsigned int> myVec(size); // create, 0-initialized

  myVec[5] = 42; // random access

  myVec.at(3) = 23; // random access with bounds checking

  myVec.resize(12); // change size

  myVec.push_back(23); // insert at (change size)
  myVec.pop_back();    // remove last element

  myVec.reserve(120); // allocation is logarithmic, but still …

  // iterate over vector
  //   note the "auto" keyword (C++ 11)
  for ( auto it = myVec.begin(); it != myVec.end(); ++it ) {
    std::cout << *it << std::endl;
  }

  myVec.clear(); // resize to 0
  // Attention: do not confuse with "set all entries to zero"

  return ( EXIT_SUCCESS );
}
